# factorial, recursively 
def factorial(n):
    if n == 0:
        return 1
    else:
        return n * factorial(n-1)
    
# factorial, using for
def factorial_for(n):
    result = 1
    for i in range(1, n+1):
        result *= i
    return result

# factorial, using while
def factorial_while(n):
    result = 1
    while n > 1:
        result *= n
        n -= 1
    return result

# test that the three functions are equivalent
for i in range(100):
    assert factorial(i) == factorial_for(i) == factorial_while(i) 

# factorial, recursively, "two at a time"
def factorial2(n):
    if n <= 1:
        return 1
    else:
        return n * (n-1) * factorial2(n-2)

# test that the "optimization" works
for i in range(10):
    assert factorial(i) == factorial2(i)

# factorial, using for, "two at a time"
def factorial2_for(n):
    result = 1
    for i in range(1, n, 2):
        result *= i * (i+1)
    if n % 2 == 1:
        result *= n
    return result

# test that the "optimization" works
for i in range(10):
   assert factorial_for(i) == factorial2_for(i)

# factorial, using while, "two at a time"
def factorial2_while(n):
    result = 1
    while n > 1:
        result *= n * (n-1)
        n -= 2
    return result

# test that the "optimization" works
for i in range(10):
   assert factorial_while(i) == factorial2_while(i)

# check upper bound on factorial
for n in range(10):
    assert factorial_while(n) <= n**n
